//Thunder Gun

//Modeled by Aware14(The cool one)

//Scripted by Ghile AKA _Dark_ (The one with herbs with hats)

//Herb Productions Inc.


datablock AudioProfile(ThunderGunFireSound)

{

   fileName = "Add-Ons/Weapon_Thunder_Gun/ThunderFiring.wav";

   description = AudioClose3d;

   preload = true;

};

datablock ParticleData(ThunderGunAmbientParticle)

{

 dragCoefficient = 1;

 windCoefficient = 0.2;

 gravityCoefficient = 0;

 inheritedVelFactor = 0.2;

 constantAcceleration = 0;

 lifetimeMS = 400;

 lifetimeVarianceMS = 100;

 textureName = "base/data/particles/cloud";

 spinSpeed = 0;

 spinRandomMin = -900;

 spinRandomMax = 900;

 useInvAlpha = false;

 colors[0] = "0.20 0.20 0.33 1";

 colors[1] = "0.50 0.50 0.67 0.8";

 colors[2] = "1 1 1 0.2";

 sizes[0] = 0.4;

 sizes[1] = 0.3;

 sizes[2] = 0.2;

 times[0] = 0;

 times[1] = 0.2;

 times[2] = 1;

};

datablock ParticleData(ThunderGunTrailParticle)

{

 dragCoefficient = 1;

 windCoefficient = 0.2;

 gravityCoefficient = 0;

 inheritedVelFactor = 0.2;

 constantAcceleration = 0;

 lifetimeMS = 400;

 lifetimeVarianceMS = 100;

 textureName = "base/data/particles/thinring";

 spinSpeed = 0;

 spinRandomMin = -900;

 spinRandomMax = 900;

 useInvAlpha = false;

 colors[0] = "0.33 0.33 0.33 1";

 colors[1] = "0.67 0.67 0.67 0.8";

 colors[2] = "1 1 1 0.2";

 sizes[0] = 0.8;

 sizes[1] = 4.0;

 sizes[2] = 0.0;

 times[0] = 0;

 times[1] = 0.2;

 times[2] = 1;

};

datablock ParticleEmitterData(ThunderGunTrailEmitter)

{

 ejectionPeriodMS = 5;

 periodVarianceMS = 0;

 ejectionVelocity = 0.0;

 velocityVariance = 0.0;

 ejectionOffset   = 1.0;

 thetaMin         = 0;

 thetaMax         = 40;

 phiReferenceVel  = 720;

 phiVariance      = 10;

 overrideAdvance = false;

 particles = "ThunderGunTrailParticle";

 uiName = "ThunderGun - Trail";

};

datablock ParticleData(ThunderGunExplosionParticle)

{

 dragCoefficient = 1;

 windCoefficient = 0;

 gravityCoefficient = 0;

 inheritedVelFactor = 0.2;

 constantAcceleration = 0;

 lifetimeMS = 750;

 lifetimeVarianceMS = 250;

 textureName = "base/data/particles/cloud";

 spinSpeed = 0;

 spinRandomMin = -1000;

 spinRandomMax = 1000;

 useInvAlpha = false;

 colors[0] = "0.33 0.33 0.33 1";

 colors[1] = "0.67 0.67 0.67 0.8";

 colors[2] = "1 1 1 0.2";

 sizes[0] = 2;

 sizes[1] = 1.8;

 sizes[2] = 1.6;

 times[0] = 0;

 times[1] = 0.2;

 times[2] = 1;

};

datablock ParticleEmitterData(ThunderGunExplosionEmitter)

{

 ejectionPeriodMS = 5;

 periodVarianceMS = 4;

 ejectionVelocity = 8;

 velocityVariance = 0.2;

 ejectionOffset = 1;

 thetaMin = 0;

 thetaMax = 180;

 phiReferenceVel = 720;

 phiVariance = 20;

 overrideAdvance = false;

 particles = "ThunderGunExplosionParticle";

};

datablock ExplosionData(ThunderGunExplosion)

{

 lifeTimeMS = 600;

 particleEmitter = ThundergunExplosionEmitter;

 particleDensity = 15;

 particleRadius = 0.5;

 

 faceViewer = true;

 explosionScale = "1 1 1";

 

 shakeCamera = True;

 camShakeFreq = "1 1 1";

 camShakeAmp = "1 1 1";

 camShakeDuration = 0;

 camShakeRadius = 0;

 lightStartRadius = 0;

 lightEndRadius = 0;

 lightStartColor = "1 1 1";

 lightEndColor = "1 1 1";

 damageRadius = 5;

 radiusDamage = 100;
 
 impulseRadius  = 6;
 impulseForce   = 4000;

};

AddDamageType("ThundergunDirect",   '<bitmap:add-ons/Weapon_Thunder_gun/CI_Thundergun> %1',    '%2 <bitmap:add-ons/Weapon_Thunder_Gun/Icon_Thunder> %1',1,1);

AddDamageType("ThundergunRadius",   '<bitmap:add-ons/Weapon_Thunder_Gun/CI_Thundergun> %1',    '%2 <bitmap:add-ons/Weapon_Thunder_Gun/Icon_Thunder> %1',1,0);

datablock ProjectileData(ThundergunProjectile)

{

   projectileShapeName = "base/data/shapes/empty.dts";

   directDamage        = 1000;

   directDamageType = $DamageType::ThundergunDirect;

   radiusDamageType = $DamageType::ThundergunRadius;

   impactImpulse    = 1000;

   verticalImpulse    = 1000;

   explosion           = ThundergunExplosion;

   particleEmitter     = ThundergunTrailEmitter;

   brickExplosionRadius = 0;

   brickExplosionImpact = true;

   brickExplosionForce = 5;

   brickExplosionMaxVolume = 1;

   brickExplosionMaxVolumeFloating = 2;

   muzzleVelocity      = 65;

   velInheritFactor    = 1.0;

   armingDelay         = 00;

   lifetime            = 4000;

   fadeDelay           = 3500;

   bounceElasticity    = 0.5;

   bounceFriction      = 0.20;

   isBallistic         = false;

   gravityMod = 0.0;

   hasLight    = false;

   lightRadius = 5.0;

   lightColor  = "1 1 1";

   uiName = "Thundergun";

};


function ThunderGunProjectile::RadiusDamage(%this, %obj, %col, %dist, %pos, %amt)

{

 parent::RadiusDamage(%this, %obj, %col, %dist, %pos, %amt);

 if(isObject(%col) && %col.getType() & $Typemasks::PlayerObjectType)

 {

  %col.setVelocity(vectorAdd(%col.getVelocity(), vectorScale(setWord(vectorScale(%obj.getVelocity(), getWord(%obj.getScale(), 2)), 2, "10"), 0.2)));

 }

}

datablock ItemData(ThunderGunItem)

{

 category = "Weapon";

 className = "Weapon";

shapeFile = "Add-Ons/Weapon_Thunder_Gun/ThunderGun.dts";

 rotate = false;

 mass = 0.5;

 density = 0.7;

 elasticity = 0.6;

 friction = 0.6;

 emap = true;

 uiName = "ThunderGun";

 iconName = "Add-Ons/Weapon_Thunder_Gun/CI_Thundergun";

 doColorShift = false;

 colorShiftColor = "0.5 0.5 1 1";

 image = ThunderGunImage;

 canDrop = true;

};

datablock ShapeBaseImageData(ThunderGunImage)

{

   shapeFile = "Add-Ons/Weapon_Thunder_Gun/ThunderGun.dts";

   emap = true;

   mountPoint = 0;

   offset = "0 0 0";

   eyeOffset = 0;

   rotation = "0 0 0";

   correctMuzzleVector = true;

   className = "WeaponImage";

   item = ThunderGunItem;

   ammo = " ";

   projectile = ThunderGunProjectile;

   projectileType = Projectile;

 minShotTime = 500;

   melee = false;

   armReady = true;

   doColorShift = false;

   colorShiftColor = "1 1 1 1";

 stateName[0]                   = "Activate";

 stateTimeoutValue[0]           = 0.15;

 stateTransitionOnTimeout[0]    = "Ready";

 stateSound[0]                  = weaponSwitchSound;

 stateName[1]                   = "Ready";

 stateTransitionOnTriggerDown[1]= "Fire";

 stateAllowImageChange[1]       = true;

 stateName[2]                   = "Fire";

 stateTransitionOnTimeout[2]    = "Ready";

 stateTimeoutValue[2]           = 0.5;

 stateFire[2]                   = true;

 stateSound[2]     = ThundergunFireSound;

 stateAllowImageChange[2]       = false;

 stateSequence[2]               = "Water";

 stateScript[2]                 = "onFire";

 stateWaitForTimeout[2]         = true;

 stateName[3]                   = "Reload";

 stateTransitionOnTriggerUp[3]  = "Ready";

};

